Subject: How to support non-contigous RAM?

From: [email-masked] (Reinhard Schu)

Hi all,

I heard of some guys who built a non-contigous RAM supporting kernel.

I would like to now how to do this. My configuration is as follows:

A2000 2MB Chip-RAM
A2630 with 4MB 32bit RAM          (usable for DMA)
GVP-SSCSI with 4MB 16bit RAM      (usable for DMA)
Access32 (Memory Espander for A2630) with 4MB 32 bit RAM (not usable for DMA)

Net BSD says at booting:

real  mem = 7864320 (960 pages)
avail mem = 6381568 (779 pages)
using 60 buffers containing 491520 bytes of memory
memory segment 0 at 00280000 size 00780000
                                  ^^^^^^^^^^  This is the 2630´s an the GVP´s
                                              RAM in one block of 8MB.
                                              (the lack of 1/2 MB is due to
                                               KS 3.1 loaded into RAM when 
                                               doing loadbsd)
memory segment 1 at 02000000 size 00400000
                                  ^^^^^^^^^   This is the Access 32`s RAM
memory segment 2 at 00000000 size 00200000
                                  ^^^^^^^^^   This is the Chip-Ram

real  mem = 7864320 (960 pages)
            ^^^^^^^^   obviously, NetBSD uses only segment 0, but not segment 1.

What I would like to do is: Get rid of the slow 16 bit RAM in the GVP-SCSI.
However, if I do so, NetBSD will show "real mem 3,5 MB". Thus, what I need
is a kernel which works with non-contigous RAM:

4MB (at $00280000) (A2630) 
4MB (at $02000000) (Acess32)

(The Acess32 can take up to 32 Megs of 32-bit RAM)

Antother problem is DMA. Only the A2630`s RAM is usable for DMA. How does the
kernel know about this? Has ist something to to with:

[Boot message]
ztwobus0 at mainbus0
gvpbus0 at ztwobus0 rom 0xe90000 man/pro 2017/11
gtsc0 at gvpbus0: dmamask 0xffffff maxdma 65536
scsibus0 at gtsc0         ^^^^^^^^  
                              this seems to limit DMA space to the lower 16 MB,

Any contributions?

Beste Gruesse,
Best Regards,
Reinhard Schu

-----------------------------------------------------  UNIVERSITAS  -
-  UNIVERSITAET DES SAARLANDES  ---       -----------     |\ /|     -
-------------------------------------       ---------   |||* *|||   -
-  Reinhard Schu                    ---       -------   ||| V |||   -
-  Lehrstuhl Prof. Ruessmann          ---       -----   |||   |||   -
-   Tel.: +49-(0)681-302-3101           ---       ---   |/|___|\|   -
-  Fachschaft Jura                        ---       -     +   +     -
-   Tel.: +49-(0)681-302-4121               ---        SARAVIENSIS  -
---------------------------------------------------------------------

E-Mail: [email-masked]